<!doctype html>
<html lang="fr">

<head>
    <meta charset="utf-8">
    <title>SSL/TLS</title>
    <link rel='stylesheet' type='text/css' href='assets/style.css'>

    <!-- Link your JavaScript file -->
    <script type="text/javascript" src="assets/script.js"></script>
</head>

<body>
    <h1>Travaux pratiques SSL/TLS</h1>
    <p>Auteurs: Samuel HIRON et Emmanuel KONAN</p>

    <h2>Mise en place du service de vidéo-surveillance</h2>
    <p>
        Après avoir fait les configurations réseaux pour que tous les appareils puissent s'échanger des paquets ICMP
        (ping), nous nous assurons que le flux de la vidéo de la machine Caméra est visible sur la machine Visu. La vidéo
        présente une personne ouvrant un coffre fort.
    </p>

    <video width="1000" controls>
        <source src="assets/medias/camera_visu.webm" type="video/webm">
    </video>
    <p>
        Cependant, grâce à son accès au firewallen ssh et à ses privilèges, l'attaquant peut modifier le la table de routage du firewall de sorte à transmettre un flux vidéo factice à la machine Visu sur lequel l'on voit une porte fermée. <br>
    </p>

    <video width="1000" controls>
        <source src="assets/medias/attaque_simple.mp4" type="video/mp4">
    </video>


    <p>
        Pour nous prémunir de cette attaque, nous allons mettre en place un tunnel chiffré et intègre entre les machines
        Visu et Camera grâce au protocole SSL/TLS.
    </p>

    <h2>Mise en place d'une infrastructure à clé publique</h2>
    <p>
        TLS nécessite l'utilisation de certificat ce qui suppose la mise en place d'une PKI (Public Key Infrastructure).
        Pour cela nous générons un certificat auto-signé qui représentera une autorité de certification racine (CA) :
    </p>
    <code>
    openssl req -new -x509 -nodes -newkey rsa:2048-config ./openssl.cnf -keyout private/cakey.pem -out cacert.pem
        </code>
    <ul>
        <li>req : permet de générer une demande de certification</li>
        <li>new : permet de générer une nouvelle demande de certification</li>
        <li>x509 : permet de générer des certificats sous le standard X.509, il s'agit d'un standard promulgué par
            l'UIT. </li>
        <li>newkey rsa:2048 : permet de générer une clé privée de 2048 bits</li>
        <li>config ./openssl.cnf : permet de spécifier le fichier de configuration</li>
        <li>keyout private/cakey.pem : permet de spécifier le fichier de sortie de la clé privée</li>
        <li>nodes : permet de ne pas chiffré la clé en sortie, cela implique de définir des droits d'accès spécifiques
            au
            fichier qui contient la clef privée de peur que celle-ci ne soit dérobée par des personnes illégitimes.</li>
        <li>out cacert.pem : permet de spécifier le fichier de sortie du certificat</li>
    </ul>

    <p>
        Nous pouvons visualiser le contenu du certificat et de la clé à l'aide des commandes: <br>
        <code>
            openssl x509 -in cacert.pem -text <br> 
            openssl rsa -in private/cakey.pem -text <br>
         </code>
    </p>

    <h2>Génération du certificat du serveur</h2>
    <p>La communication TLS a lieu entre le serveur (Camera) et le client (Visu). Ces deux entités doivent posséder
        chacun un certificat. Ci-dessous nous générons une demande de certification qui sera validé par le CA.
    </p>
    <code>
        openssl req -nodes -newkey rsa:2048 -config ./openssl.cnf -keyout serverkey.pem -out serverreq.pem <br>
        openssl ca -config ./openssl.cnf -in serverreq.pem -out servercert.pem
        </code>

    <p>
        La différence entre le certificat et la demande de certification est que les informations relatives à l'autorité
        de certification se sont rajoutées. Nous avons notamment le champ "issuer":
    </p>

    <img src="assets/medias/issuer.jpg" alt="certificat_camera" width="1000">

    <h2> Mise en place d'un tunnel SSL entre Visu et Camera</h2>
    <p>En utilisant wireshark, nous remarquons que le traffic est chiffré entre Caméra et Visu.
    </p>

    <img src="assets/medias/ssl_visu_camera.png" alt="ssl_visu_camera" width="1000">
    <video width="1000" controls>
        <source src="assets/medias/flux_chiffré.mp4" type="video/mp4">
    </video>
    <p>
    Nous ne pouvons plus reproduire cette attaque à cause du chiffrement. En effet, l'attaquant ne produit pas le flux SSL/TLS attendu par Visu, il faut donc adapter l'attaque.</p>
    <p> Nous avons donc configuré la machine Attaquant pour qu'elle offre également une connexion TLS.
    Nous avons généré une certificat auto-signé sur la machine Attaquant et mis en place le tunnel TLS adéquate.
    Nous avons également ajouté un script de routage adapté à cette nouvelle configuration de l'attaquant (port 1200).</p>
    <img src="assets/medias/ssl_visu_attaquant.png" alt="ssl_visu_attaquant" width="1000">
    
    <video width="1000" controls>
        <source src="assets/medias/attaque_ssl.mp4" type="video/mp4">
    </video>
</body>
